//######################################################################################
/*
 * Created on 07-Feb-2004
 * Author is Michael Camacho
 *
 */
//######################################################################################
package pipe.gui;

import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;
//######################################################################################
public class ModuleLoader implements Constants {
//######################################################################################
	public ModuleLoader() {

	}
//######################################################################################
	public static Class importModule(File modFile)
	{
		String pFileName = modFile.getName();
		Properties prop = new Properties();
		Class modClass = null;
		
		if (pFileName.endsWith(PROPERTY_FILE_EXTENSION)
				&&modFile.exists() && modFile.isFile() && modFile.canRead())
		{
			
			try
			{
				prop.load(new FileInputStream(modFile));
			}
			catch (Exception e)
			{
				System.out.println("Error loading " + pFileName);
				return null;
			}

			ExtFileManager.addSearchPath(modFile.getParentFile());
			String moduleClassName = (String)prop.get( "module.class");
			
			try
			{
				modClass = ExtFileManager.loadExtClass(moduleClassName);	
				if (!isModule(modClass))
				{
					System.out.println(moduleClassName + " is not a valid module Class");
					return null;
				}
			}
			catch (Exception e)
			{
			}
		}
		return modClass;
	}
//######################################################################################
	public static boolean isModule(Class modClass)
	{
		Class interfaces[] = modClass.getInterfaces();
		for (int i=0; i<interfaces.length; i++)
		{
			if (interfaces[i].getName() == "pipe.modules.Module")
			{
				return true;
			}
		}
		return false;
	}
//######################################################################################
}
//######################################################################################